#!/bin/sh

[ "${INSTDIR}" ] || INSTDIR=/

if [ -z "$1" ] ; then
	echo "$0: Expected COMMAND [and EGPFILE]" 1>&2
	exit 1
else
	COMMAND=$1
	shift
fi

case ${COMMAND} in
install|uninstall)	;;
*)		echo "$0: Bad COMMAND ${COMMAND}" 1>&2 ; exit 1 ;;
esac

if [ -z "$1" ] ; then
	echo "$0: Expected EGPFILE" 1>&2
	exit 1
fi

while [ "$1" ] ; do
	EGPFILE=$1
	shift

	case ${COMMAND} in
	install)	tar xzOf ${EGPFILE} files.tar | ( cd ${INSTDIR} && tar xvf - ) ;;
	uninstall)	tar xzOf ${EGPFILE} files.tar | tar tf - | while read FILE ; do
				[ -d /${FILE} ] && rmdir /${FILE} 2>/dev/null
				[ -f /${FILE} ] && rm /${FILE}
			done ;;
	esac
done
